<template>
  <v-card
    class="course-card studium-card"
    elevation="0"
    rounded="lg"
    :style="{ '--course-card-border-color': borderColor }"
    :to="localePath({ name: 'course-code-tab', params: { code: course.code, tab: 'description' } })"
    :ripple="false"
    data-cy="course-link"
  >
    <!-- Title -->
    <v-row no-gutters>
      <v-col cols="10">
        <div class="course-card-title studium-hyphenate">
          {{ course.name }}
        </div>
      </v-col>
    </v-row>

    <!-- Details -->
    <v-row no-gutters justify="space-between" class="course-card-details">
      <v-col cols="auto">
        {{ instructor }}
      </v-col>

      <v-col cols="auto" class="secondary--text">
        {{ course.code }}
      </v-col>
    </v-row>

    <!-- Actions -->
    <div class="course-card-actions">
      <!-- Unsubscribe -->
      <v-btn
        v-if="course.subscribed"
        icon
        medium
        color="primary"
        :loading="subscriptionMutation.loading.value"
        @click.prevent="subscriptionMutation.mutate({ code: course.code, value: false })"
      >
        <v-icon>mdi-star</v-icon>
      </v-btn>

      <!-- Subscribe -->
      <v-btn
        v-else
        icon
        medium
        color="primary"
        :loading="subscriptionMutation.loading.value"
        @click.prevent="subscriptionMutation.mutate({ code: course.code, value: true })"
      >
        <v-icon>mdi-star-outline</v-icon>
      </v-btn>
    </div>
  </v-card>
</template>

<script lang="ts">
import { computed, defineComponent } from '@vue/composition-api'
import ColorHash from 'color-hash'

import { useChangeCourseSubscriptionMutation } from '~/apollo/_generated'
import { subscriptionsUpdater } from '~/util/cache/'
import { useErrorHandler } from '~/util/composables'

export default defineComponent({
  props: {
    course: {
      type: Object,
      default() {
        return {}
      },
    },
  },
  setup(props, { emit }) {
    // Instructors for the course
    const instructor = computed(() => props.course.instructor?.name || 'Not Specified')

    // Color of the left border
    const borderColor = computed(() => new ColorHash({ saturation: 1, lightness: 0.7 }).hex(props.course.name))

    // Subscribe/unsubscribe to course mutation.
    const subscriptionMutation = useChangeCourseSubscriptionMutation({ update: subscriptionsUpdater })
    const subscriptionMutationError = useErrorHandler(subscriptionMutation)

    // Handle potential error
    subscriptionMutation.onError(() => emit('error', subscriptionMutationError.value))

    return {
      instructor,
      borderColor,
      subscriptionMutation,
    }
  },
})
</script>

<style lang="scss" scoped>
.course-card {
  $hover-transition-timings: cubic-bezier(0.5, 1, 0.89, 1);
  $hover-transition-duration: 0.2s;

  padding: 22px 20px;
  position: relative;
  transition: border-width $hover-transition-duration $hover-transition-timings;
  border-left: 10px solid var(--course-card-border-color);

  display: flex;
  flex-direction: column;
  justify-content: space-between;

  &:hover {
    border-width: 20px;

    .course-card-title {
      margin-right: 0;
    }
  }

  &-title {
    font-size: 1.25rem;
    font-weight: 700;
    color: $primary;

    // Prevent jumping of title on hover (https://gitlab.com/vtkgent/studium/frontend/-/issues/261)
    transition: margin $hover-transition-duration $hover-transition-timings;
    margin-right: 10px;
  }

  &-details {
    font-size: 0.875rem;
    font-weight: 400;
    padding-top: 8px;
    flex-grow: 0;
  }

  &-actions {
    position: absolute;
    top: 10px;
    right: 10px;
  }
}
</style>
